//+------------------------------------------------------------------+
//|                                                          PPO.mq4 |
//|                                       Copyright  2007 Tom Balfe |
//|                                                                  |
//| Percentage Price Oscillator                                      |
//| This is a momentum indicator.                                    |
//| Signal line is HMA of PPO.                                       |
//|                                                                  |
//| Follows formula: (FastHMA-SlowHMA)/SlowHMA                       |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Tom Balfe"
#property link      "redcarsarasota@yahoo.com"
//----
#property indicator_separate_window
#property indicator_buffers 2
//----
#property indicator_color1 SkyBlue
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 1
#property indicator_style2 2
//---- user changeable stuff
extern int FastHMA=12;
extern int SlowHMA=26;
extern int SignalHMA=9;

//---- two buffers
double     PPOBuffer[];
double     SignalBuffer[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(1,SignalHMA);
   IndicatorDigits(Digits+1);
   SetIndexBuffer(0,PPOBuffer);
   SetIndexBuffer(1,SignalBuffer);
//----
   IndicatorShortName("PPO_HMA ("+FastHMA+","+SlowHMA+","+SignalHMA+")");
   SetIndexLabel(0,"PPO_HMA");
   SetIndexLabel(1,"Signal");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- (FastHMA-SlowHMA)/SlowHMA
//---- PPO counted in the 1st buffer
   for(int i=0; i<limit; i++)
 //  hmas=NormalizeDouble(iCustom(NULL,0,perlow,1),Digits); 
      {
         double slow = NormalizeDouble(iCustom(NULL,0,"HMA",SlowHMA,0,i),Digits);
         if (slow!=0)
            PPOBuffer[i]=(NormalizeDouble(iCustom(NULL,0,"HMA",FastHMA,0,i),Digits)-slow)/slow;
      }            
//---- signal line counted in the 2nd buffer
   for(i=0; i<limit; i++)
      SignalBuffer[i]=iMAOnArray(PPOBuffer,Bars,SignalHMA,0,MODE_EMA,i);
   return(0);
  }
//+------------------------------------------------------------------+